
#include "bits/bit-paper-fold.h"

#include "demo/nextarg.h"
#include "fxttypes.h"  // ulong

#include "jjassert.h"


//% Generate the alternate paper-folding sequence.


int
main(int argc, char **argv)
{
    ulong n = 65;
    NXARG(n, "Number of bits generated");

    ulong dir = 0;
    for (ulong k=1; k<=n; ++k)  // note start with k==1
    {
        bool p = bit_paper_fold_alt(k);
        cout << (p==0 ? '.' : '1' );  // A106665, dots for zeros
//        cout << (p==0 ? '0' : '1' ) << ", ";  // A106665

        dir += (p ? +1UL : -1UL );   dir &= 3;    // modulo 4
        ulong t = bit_paper_fold_alt_rot(k);
//        cout << "[" << dir << "," << t << "]";
//        cout << "[" << dir << "]";
//        cout << dir << ",";
        jjassert( t == dir );
    }
    cout << endl;

    return 0;
}
// -------------------------


/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/bits"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/bits/bit-paper-fold-alt-demo.cc"
/// make-target2: "1demo DSRC=demo/bits/bit-paper-fold-alt-demo.cc DEMOFLAGS=-DTIMING"
/// End:

